Hex Artifact Content

Artifact 7f9ef1ab4d694795165c1dc220cd29cca4b97711:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 66 32 34 33 35 33 64 30  bash..# f24353d0
0020: 32 64 39 30 66 39 37 63 37 32 62 36 39 37 37 66  2d90f97c72b6977f
0030: 33 61 38 61 30 35 30 30 36 61 64 30 36 31 32 30  3a8a05006ad06120
0040: 0a 0a 6f 75 72 53 63 72 69 70 74 3d 22 24 28 77  ..ourScript="$(w
0050: 68 69 63 68 20 22 24 30 22 29 22 0a 69 66 20 21  hich "$0")".if !
0060: 20 68 65 61 64 20 2d 33 20 22 24 7b 6f 75 72 53   head -3 "${ourS
0070: 63 72 69 70 74 7d 22 20 32 3e 2f 64 65 76 2f 6e  cript}" 2>/dev/n
0080: 75 6c 6c 20 7c 20 67 72 65 70 20 66 32 34 33 35  ull | grep f2435
0090: 33 64 30 32 64 39 30 66 39 37 63 37 32 62 36 39  3d02d90f97c72b69
00a0: 37 37 66 33 61 38 61 30 35 30 30 36 61 64 30 36  77f3a8a05006ad06
00b0: 31 32 30 20 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20  120 >/dev/null; 
00c0: 74 68 65 6e 0a 09 65 63 68 6f 20 22 65 72 72 6f  then..echo "erro
00d0: 72 3a 20 55 6e 61 62 6c 65 20 74 6f 20 66 69 6e  r: Unable to fin
00e0: 64 20 6f 75 72 73 65 6c 76 65 73 22 20 3e 26 32  d ourselves" >&2
00f0: 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 63 64  ...exit 1.fi..cd
0100: 20 22 24 28 64 69 72 6e 61 6d 65 20 22 24 7b 6f   "$(dirname "${o
0110: 75 72 53 63 72 69 70 74 7d 22 29 22 20 7c 7c 20  urScript}")" || 
0120: 65 78 69 74 20 31 0a 0a 70 61 74 63 68 44 69 72  exit 1..patchDir
0130: 3d 22 24 28 70 77 64 29 2f 70 61 74 63 68 65 73  ="$(pwd)/patches
0140: 22 0a 0a 66 75 6e 63 74 69 6f 6e 20 64 6f 77 6e  "..function down
0150: 6c 6f 61 64 28 29 20 7b 0a 09 6c 6f 63 61 6c 20  load() {..local 
0160: 75 72 6c 20 66 69 6c 65 20 68 61 73 68 0a 09 6c  url file hash..l
0170: 6f 63 61 6c 20 68 61 73 68 4d 65 74 68 6f 64 0a  ocal hashMethod.
0180: 09 6c 6f 63 61 6c 20 63 68 6b 48 61 73 68 0a 0a  .local chkHash..
0190: 09 75 72 6c 3d 22 24 31 22 0a 09 66 69 6c 65 3d  .url="$1"..file=
01a0: 22 24 32 22 0a 09 68 61 73 68 3d 22 24 33 22 0a  "$2"..hash="$3".
01b0: 0a 09 69 66 20 5b 20 2d 66 20 22 24 7b 66 69 6c  ..if [ -f "${fil
01c0: 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 72 65  e}" ]; then...re
01d0: 74 75 72 6e 20 30 0a 09 66 69 0a 0a 09 6d 6b 64  turn 0..fi...mkd
01e0: 69 72 20 2d 70 20 22 24 28 64 69 72 6e 61 6d 65  ir -p "$(dirname
01f0: 20 22 24 7b 66 69 6c 65 7d 22 29 22 0a 0a 09 68   "${file}")"...h
0200: 61 73 68 4d 65 74 68 6f 64 3d 27 73 68 61 32 35  ashMethod='sha25
0210: 36 27 0a 0a 09 72 6d 20 2d 66 20 22 24 7b 66 69  6'...rm -f "${fi
0220: 6c 65 7d 2e 6e 65 77 22 0a 09 77 67 65 74 20 2d  le}.new"..wget -
0230: 2d 68 65 61 64 65 72 20 22 58 2d 43 61 63 68 65  -header "X-Cache
0240: 2d 55 52 4c 3a 20 24 7b 75 72 6c 7d 22 20 2d 4f  -URL: ${url}" -O
0250: 20 22 24 7b 66 69 6c 65 7d 2e 6e 65 77 22 20 22   "${file}.new" "
0260: 68 74 74 70 3a 2f 2f 68 61 73 68 63 61 63 68 65  http://hashcache
0270: 2e 72 6b 65 65 6e 65 2e 6f 72 67 2f 24 7b 68 61  .rkeene.org/${ha
0280: 73 68 4d 65 74 68 6f 64 7d 2f 24 7b 68 61 73 68  shMethod}/${hash
0290: 7d 22 20 7c 7c 20 5c 0a 09 09 77 67 65 74 20 2d  }" || \...wget -
02a0: 4f 20 22 24 7b 66 69 6c 65 7d 2e 6e 65 77 22 20  O "${file}.new" 
02b0: 22 24 7b 75 72 6c 7d 22 20 7c 7c 20 5c 0a 09 09  "${url}" || \...
02c0: 72 65 74 75 72 6e 20 31 0a 0a 09 63 68 6b 48 61  return 1...chkHa
02d0: 73 68 3d 22 24 28 6f 70 65 6e 73 73 6c 20 22 24  sh="$(openssl "$
02e0: 7b 68 61 73 68 4d 65 74 68 6f 64 7d 22 20 22 24  {hashMethod}" "$
02f0: 7b 66 69 6c 65 7d 2e 6e 65 77 22 20 7c 20 73 65  {file}.new" | se
0300: 64 20 27 73 40 2e 2a 3d 20 2a 40 40 27 29 22 0a  d 's@.*= *@@')".
0310: 0a 09 69 66 20 5b 20 22 24 7b 63 68 6b 48 61 73  ..if [ "${chkHas
0320: 68 7d 22 20 21 3d 20 22 24 7b 68 61 73 68 7d 22  h}" != "${hash}"
0330: 20 5d 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f 20   ]; then...echo 
0340: 22 65 72 72 6f 72 3a 20 43 68 65 63 6b 73 75 6d  "error: Checksum
0350: 20 6d 69 73 6d 61 74 63 68 3a 20 47 6f 74 3a 20   mismatch: Got: 
0360: 24 7b 63 68 6b 48 61 73 68 7d 3b 20 45 78 70 65  ${chkHash}; Expe
0370: 63 74 65 64 3a 20 24 7b 68 61 73 68 7d 22 20 3e  cted: ${hash}" >
0380: 26 32 0a 0a 09 09 72 65 74 75 72 6e 20 31 0a 09  &2....return 1..
0390: 66 69 0a 0a 09 6d 76 20 22 24 7b 66 69 6c 65 7d  fi...mv "${file}
03a0: 2e 6e 65 77 22 20 22 24 7b 66 69 6c 65 7d 22 0a  .new" "${file}".
03b0: 0a 09 72 65 74 75 72 6e 20 30 0a 7d 0a 0a 66 75  ..return 0.}..fu
03c0: 6e 63 74 69 6f 6e 20 65 78 74 72 61 63 74 28 29  nction extract()
03d0: 20 7b 0a 09 6c 6f 63 61 6c 20 66 69 6c 65 20 64   {..local file d
03e0: 69 72 65 63 74 6f 72 79 0a 0a 09 66 69 6c 65 3d  irectory...file=
03f0: 22 24 31 22 0a 09 64 69 72 65 63 74 6f 72 79 3d  "$1"..directory=
0400: 22 24 32 22 0a 0a 09 69 66 20 5b 20 21 20 2d 66  "$2"...if [ ! -f
0410: 20 22 24 7b 66 69 6c 65 7d 22 20 5d 3b 20 74 68   "${file}" ]; th
0420: 65 6e 0a 09 09 65 63 68 6f 20 22 65 72 72 6f 72  en...echo "error
0430: 3a 20 55 6e 61 62 6c 65 20 74 6f 20 65 78 74 72  : Unable to extr
0440: 61 63 74 20 5c 22 24 7b 66 69 6c 65 7d 5c 22 22  act \"${file}\""
0450: 20 3e 26 32 0a 0a 09 09 72 65 74 75 72 6e 20 31   >&2....return 1
0460: 0a 09 66 69 0a 0a 09 72 6d 20 2d 72 66 20 22 24  ..fi...rm -rf "$
0470: 7b 64 69 72 65 63 74 6f 72 79 7d 22 0a 0a 09 6d  {directory}"...m
0480: 6b 64 69 72 20 2d 70 20 22 24 7b 64 69 72 65 63  kdir -p "${direc
0490: 74 6f 72 79 7d 22 20 7c 7c 20 72 65 74 75 72 6e  tory}" || return
04a0: 20 31 0a 09 28 0a 09 09 63 64 20 22 24 7b 64 69   1..(...cd "${di
04b0: 72 65 63 74 6f 72 79 7d 22 20 7c 7c 20 65 78 69  rectory}" || exi
04c0: 74 20 31 0a 0a 09 09 63 61 73 65 20 22 24 7b 66  t 1....case "${f
04d0: 69 6c 65 7d 22 20 69 6e 0a 09 09 09 2a 2e 74 61  ile}" in....*.ta
04e0: 72 2e 62 7a 32 7c 2a 2e 62 7a 32 29 0a 09 09 09  r.bz2|*.bz2)....
04f0: 09 62 7a 69 70 32 20 2d 64 63 20 7c 20 74 61 72  .bzip2 -dc | tar
0500: 20 2d 78 66 20 2d 20 7c 7c 20 65 78 69 74 20 31   -xf - || exit 1
0510: 0a 09 09 09 09 3b 3b 0a 09 09 09 2a 2e 74 61 72  .....;;....*.tar
0520: 2e 67 7a 7c 2a 2e 74 67 7a 29 0a 09 09 09 09 67  .gz|*.tgz).....g
0530: 7a 69 70 20 2d 64 63 20 7c 20 74 61 72 20 2d 78  zip -dc | tar -x
0540: 66 20 2d 20 7c 7c 20 65 78 69 74 20 31 0a 09 09  f - || exit 1...
0550: 09 09 3b 3b 0a 09 09 09 2a 2e 74 61 72 2e 78 7a  ..;;....*.tar.xz
0560: 7c 2a 2e 74 78 7a 29 0a 09 09 09 09 78 7a 20 2d  |*.txz).....xz -
0570: 64 63 20 7c 20 74 61 72 20 2d 78 66 20 2d 20 7c  dc | tar -xf - |
0580: 7c 20 65 78 69 74 20 31 0a 09 09 09 09 3b 3b 0a  | exit 1.....;;.
0590: 09 09 09 2a 29 0a 09 09 09 09 65 63 68 6f 20 22  ...*).....echo "
05a0: 65 72 72 6f 72 3a 20 44 6f 6e 27 74 20 6b 6e 6f  error: Don't kno
05b0: 77 20 77 68 61 74 20 74 6f 20 64 6f 20 77 69 74  w what to do wit
05c0: 68 20 5c 22 24 7b 66 69 6c 65 7d 5c 22 22 20 3e  h \"${file}\"" >
05d0: 26 32 0a 0a 09 09 09 09 65 78 69 74 20 31 0a 09  &2......exit 1..
05e0: 09 09 09 3b 3b 0a 09 09 65 73 61 63 0a 0a 09 09  ...;;...esac....
05f0: 69 66 20 5b 20 2d 64 20 22 24 28 65 63 68 6f 20  if [ -d "$(echo 
0600: 2a 29 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09 6d  *)" ]; then....m
0610: 76 20 2a 2f 2a 20 2e 20 3e 2f 64 65 76 2f 6e 75  v */* . >/dev/nu
0620: 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 09  ll 2>/dev/null..
0630: 09 66 69 0a 09 29 20 3c 20 22 24 7b 66 69 6c 65  .fi..) < "${file
0640: 7d 22 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a 0a  }" || return 1..
0650: 09 72 65 74 75 72 6e 20 30 0a 7d 0a 0a 66 75 6e  .return 0.}..fun
0660: 63 74 69 6f 6e 20 6d 61 6b 65 28 29 20 7b 0a 09  ction make() {..
0670: 22 24 7b 4d 41 4b 45 3a 2d 24 28 77 68 69 63 68  "${MAKE:-$(which
0680: 20 6d 61 6b 65 29 7d 22 20 22 24 40 22 0a 7d 0a   make)}" "$@".}.
0690: 0a 66 75 6e 63 74 69 6f 6e 20 62 75 69 6c 64 4c  .function buildL
06a0: 69 62 55 53 42 28 29 20 7b 0a 09 6c 6f 63 61 6c  ibUSB() {..local
06b0: 20 76 65 72 73 69 6f 6e 20 75 72 6c 20 70 6b 67   version url pkg
06c0: 20 73 68 61 32 35 36 20 63 6f 6e 66 69 67 75 72   sha256 configur
06d0: 65 5f 65 78 74 72 61 0a 09 6c 6f 63 61 6c 20 61  e_extra..local a
06e0: 72 63 68 69 76 65 20 77 6f 72 6b 64 69 72 20 69  rchive workdir i
06f0: 6e 73 74 64 69 72 0a 0a 09 70 6b 67 3d 27 6c 69  nstdir...pkg='li
0700: 62 75 73 62 27 0a 09 76 65 72 73 69 6f 6e 3d 27  busb'..version='
0710: 31 2e 30 2e 39 27 0a 09 75 72 6c 3d 22 68 74 74  1.0.9'..url="htt
0720: 70 3a 2f 2f 73 6f 75 72 63 65 66 6f 72 67 65 2e  p://sourceforge.
0730: 6e 65 74 2f 70 72 6f 6a 65 63 74 73 2f 6c 69 62  net/projects/lib
0740: 75 73 62 2f 66 69 6c 65 73 2f 6c 69 62 75 73 62  usb/files/libusb
0750: 2d 31 2e 30 2f 6c 69 62 75 73 62 2d 24 7b 76 65  -1.0/libusb-${ve
0760: 72 73 69 6f 6e 7d 2f 6c 69 62 75 73 62 2d 24 7b  rsion}/libusb-${
0770: 76 65 72 73 69 6f 6e 7d 2e 74 61 72 2e 62 7a 32  version}.tar.bz2
0780: 22 0a 09 73 68 61 32 35 36 3d 27 65 39 32 30 65  "..sha256='e920e
0790: 65 64 63 32 64 30 36 62 30 39 36 30 36 36 31 31  edc2d06b09606611
07a0: 63 39 39 65 63 37 33 30 34 34 31 33 63 36 37 38  c99ec7304413c678
07b0: 34 63 62 61 36 65 33 33 39 32 38 65 37 38 32 34  4cba6e33928e7824
07c0: 33 64 33 32 33 31 39 35 66 39 62 27 0a 09 63 6f  3d323195f9b'..co
07d0: 6e 66 69 67 75 72 65 5f 65 78 74 72 61 3d 28 2d  nfigure_extra=(-
07e0: 2d 64 69 73 61 62 6c 65 2d 73 68 61 72 65 64 20  -disable-shared 
07f0: 2d 2d 65 6e 61 62 6c 65 2d 73 74 61 74 69 63 20  --enable-static 
0800: 2d 2d 77 69 74 68 2d 70 69 63 20 22 24 7b 67 6c  --with-pic "${gl
0810: 6f 62 61 6c 5f 63 6f 6e 66 69 67 75 72 65 5f 65  obal_configure_e
0820: 78 74 72 61 5b 40 5d 7d 22 29 0a 0a 09 61 72 63  xtra[@]}")...arc
0830: 68 69 76 65 3d 22 61 72 63 68 69 76 65 2f 24 7b  hive="archive/${
0840: 70 6b 67 7d 2d 24 7b 76 65 72 73 69 6f 6e 7d 2e  pkg}-${version}.
0850: 74 61 72 2e 62 7a 32 22 0a 09 77 6f 72 6b 64 69  tar.bz2"..workdi
0860: 72 3d 22 77 6f 72 6b 64 69 72 2d 24 7b 52 41 4e  r="workdir-${RAN
0870: 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52  DOM}${RANDOM}${R
0880: 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 2e  ANDOM}${RANDOM}.
0890: 62 75 69 6c 64 22 0a 09 69 6e 73 74 64 69 72 3d  build"..instdir=
08a0: 22 77 6f 72 6b 64 69 72 2d 24 7b 52 41 4e 44 4f  "workdir-${RANDO
08b0: 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e  M}${RANDOM}${RAN
08c0: 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 2e 69 6e  DOM}${RANDOM}.in
08d0: 73 74 22 0a 0a 09 64 6f 77 6e 6c 6f 61 64 20 22  st"...download "
08e0: 24 7b 75 72 6c 7d 22 20 22 24 7b 61 72 63 68 69  ${url}" "${archi
08f0: 76 65 7d 22 20 22 24 7b 73 68 61 32 35 36 7d 22  ve}" "${sha256}"
0900: 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a 09 65 78   || return 1..ex
0910: 74 72 61 63 74 20 22 24 7b 61 72 63 68 69 76 65  tract "${archive
0920: 7d 22 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20  }" "${workdir}" 
0930: 7c 7c 20 72 65 74 75 72 6e 20 31 0a 0a 09 28 0a  || return 1...(.
0940: 09 09 6d 6b 64 69 72 20 22 24 7b 69 6e 73 74 64  ..mkdir "${instd
0950: 69 72 7d 22 0a 0a 09 09 69 6e 73 74 64 69 72 3d  ir}"....instdir=
0960: 22 24 28 63 64 20 22 24 7b 69 6e 73 74 64 69 72  "$(cd "${instdir
0970: 7d 22 20 26 26 20 70 77 64 29 22 20 7c 7c 20 65  }" && pwd)" || e
0980: 78 69 74 20 31 0a 0a 09 09 63 64 20 22 24 7b 77  xit 1....cd "${w
0990: 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78 69 74  orkdir}" || exit
09a0: 20 31 0a 0a 09 09 2e 2f 63 6f 6e 66 69 67 75 72   1...../configur
09b0: 65 20 2d 2d 70 72 65 66 69 78 3d 27 27 20 22 24  e --prefix='' "$
09c0: 7b 63 6f 6e 66 69 67 75 72 65 5f 65 78 74 72 61  {configure_extra
09d0: 5b 40 5d 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a  [@]}" || exit 1.
09e0: 09 09 6d 61 6b 65 20 56 3d 31 20 7c 7c 20 65 78  ..make V=1 || ex
09f0: 69 74 20 31 0a 09 09 6d 61 6b 65 20 56 3d 31 20  it 1...make V=1 
0a00: 44 45 53 54 44 49 52 3d 22 24 7b 69 6e 73 74 64  DESTDIR="${instd
0a10: 69 72 7d 22 20 69 6e 73 74 61 6c 6c 20 7c 7c 20  ir}" install || 
0a20: 65 78 69 74 20 31 0a 09 29 20 7c 7c 20 72 65 74  exit 1..) || ret
0a30: 75 72 6e 20 31 0a 0a 09 72 6d 20 2d 72 66 20 22  urn 1...rm -rf "
0a40: 24 7b 77 6f 72 6b 64 69 72 7d 22 0a 0a 09 63 61  ${workdir}"...ca
0a50: 63 6b 65 79 43 68 72 6f 6d 65 45 78 74 4c 69 62  ckeyChromeExtLib
0a60: 55 53 42 44 69 72 3d 22 24 28 63 64 20 22 24 7b  USBDir="$(cd "${
0a70: 69 6e 73 74 64 69 72 7d 22 20 26 26 20 70 77 64  instdir}" && pwd
0a80: 29 22 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a 09  )" || return 1..
0a90: 65 78 70 6f 72 74 20 4c 49 42 55 53 42 5f 4c 49  export LIBUSB_LI
0aa0: 42 53 3d 22 2d 4c 24 7b 63 61 63 6b 65 79 43 68  BS="-L${cackeyCh
0ab0: 72 6f 6d 65 45 78 74 4c 69 62 55 53 42 44 69 72  romeExtLibUSBDir
0ac0: 7d 2f 6c 69 62 20 2d 6c 75 73 62 2d 31 2e 30 20  }/lib -lusb-1.0 
0ad0: 2d 6c 72 74 20 2d 70 74 68 72 65 61 64 22 0a 09  -lrt -pthread"..
0ae0: 65 78 70 6f 72 74 20 4c 49 42 55 53 42 5f 43 46  export LIBUSB_CF
0af0: 4c 41 47 53 3d 22 2d 49 24 7b 63 61 63 6b 65 79  LAGS="-I${cackey
0b00: 43 68 72 6f 6d 65 45 78 74 4c 69 62 55 53 42 44  ChromeExtLibUSBD
0b10: 69 72 7d 2f 69 6e 63 6c 75 64 65 2f 6c 69 62 75  ir}/include/libu
0b20: 73 62 2d 31 2e 30 22 0a 0a 09 72 65 74 75 72 6e  sb-1.0"...return
0b30: 20 30 0a 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 62   0.}..function b
0b40: 75 69 6c 64 43 43 49 44 28 29 20 7b 0a 09 6c 6f  uildCCID() {..lo
0b50: 63 61 6c 20 76 65 72 73 69 6f 6e 20 75 72 6c 20  cal version url 
0b60: 70 6b 67 20 73 68 61 32 35 36 20 63 6f 6e 66 69  pkg sha256 confi
0b70: 67 75 72 65 5f 65 78 74 72 61 0a 09 6c 6f 63 61  gure_extra..loca
0b80: 6c 20 61 72 63 68 69 76 65 20 77 6f 72 6b 64 69  l archive workdi
0b90: 72 20 69 6e 73 74 64 69 72 0a 0a 09 70 6b 67 3d  r instdir...pkg=
0ba0: 27 63 63 69 64 27 0a 09 76 65 72 73 69 6f 6e 3d  'ccid'..version=
0bb0: 27 31 2e 34 2e 32 32 27 0a 09 75 72 6c 3d 22 68  '1.4.22'..url="h
0bc0: 74 74 70 73 3a 2f 2f 61 6c 69 6f 74 68 2e 64 65  ttps://alioth.de
0bd0: 62 69 61 6e 2e 6f 72 67 2f 66 72 73 2f 64 6f 77  bian.org/frs/dow
0be0: 6e 6c 6f 61 64 2e 70 68 70 2f 66 69 6c 65 2f 34  nload.php/file/4
0bf0: 31 36 32 2f 63 63 69 64 2d 24 7b 76 65 72 73 69  162/ccid-${versi
0c00: 6f 6e 7d 2e 74 61 72 2e 62 7a 32 22 0a 09 73 68  on}.tar.bz2"..sh
0c10: 61 32 35 36 3d 27 39 63 35 63 38 62 65 34 36 35  a256='9c5c8be465
0c20: 62 36 64 33 33 33 31 36 62 65 37 61 37 65 61 37  b6d33316be7a7ea7
0c30: 32 30 63 32 34 61 37 37 36 65 32 64 37 36 62 65  20c24a776e2d76be
0c40: 39 30 37 32 31 31 36 64 32 38 66 63 39 61 64 66  9072116d28fc9adf
0c50: 35 38 63 31 30 36 27 0a 09 63 6f 6e 66 69 67 75  58c106'..configu
0c60: 72 65 5f 65 78 74 72 61 3d 28 0a 09 09 2d 2d 77  re_extra=(...--w
0c70: 69 74 68 2d 70 69 63 0a 09 09 2d 2d 64 69 73 61  ith-pic...--disa
0c80: 62 6c 65 2d 73 68 61 72 65 64 20 2d 2d 65 6e 61  ble-shared --ena
0c90: 62 6c 65 2d 73 74 61 74 69 63 20 2d 2d 65 6e 61  ble-static --ena
0ca0: 62 6c 65 2d 75 73 62 0a 09 09 2d 2d 65 6e 61 62  ble-usb...--enab
0cb0: 6c 65 2d 75 73 62 64 72 6f 70 64 69 72 3d 2f 64  le-usbdropdir=/d
0cc0: 72 69 76 65 72 73 0a 09 09 22 24 7b 67 6c 6f 62  rivers..."${glob
0cd0: 61 6c 5f 63 6f 6e 66 69 67 75 72 65 5f 65 78 74  al_configure_ext
0ce0: 72 61 5b 40 5d 7d 22 0a 09 29 0a 0a 09 61 72 63  ra[@]}"..)...arc
0cf0: 68 69 76 65 3d 22 61 72 63 68 69 76 65 2f 24 7b  hive="archive/${
0d00: 70 6b 67 7d 2d 24 7b 76 65 72 73 69 6f 6e 7d 2e  pkg}-${version}.
0d10: 74 61 72 2e 62 7a 32 22 0a 09 77 6f 72 6b 64 69  tar.bz2"..workdi
0d20: 72 3d 22 77 6f 72 6b 64 69 72 2d 24 7b 52 41 4e  r="workdir-${RAN
0d30: 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52  DOM}${RANDOM}${R
0d40: 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 2e  ANDOM}${RANDOM}.
0d50: 62 75 69 6c 64 22 0a 09 69 6e 73 74 64 69 72 3d  build"..instdir=
0d60: 22 77 6f 72 6b 64 69 72 2d 24 7b 52 41 4e 44 4f  "workdir-${RANDO
0d70: 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e  M}${RANDOM}${RAN
0d80: 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 2e 69 6e  DOM}${RANDOM}.in
0d90: 73 74 22 0a 0a 09 64 6f 77 6e 6c 6f 61 64 20 22  st"...download "
0da0: 24 7b 75 72 6c 7d 22 20 22 24 7b 61 72 63 68 69  ${url}" "${archi
0db0: 76 65 7d 22 20 22 24 7b 73 68 61 32 35 36 7d 22  ve}" "${sha256}"
0dc0: 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a 09 65 78   || return 1..ex
0dd0: 74 72 61 63 74 20 22 24 7b 61 72 63 68 69 76 65  tract "${archive
0de0: 7d 22 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20  }" "${workdir}" 
0df0: 7c 7c 20 72 65 74 75 72 6e 20 31 0a 0a 09 28 0a  || return 1...(.
0e00: 09 09 6d 6b 64 69 72 20 22 24 7b 69 6e 73 74 64  ..mkdir "${instd
0e10: 69 72 7d 22 0a 0a 09 09 69 6e 73 74 64 69 72 3d  ir}"....instdir=
0e20: 22 24 28 63 64 20 22 24 7b 69 6e 73 74 64 69 72  "$(cd "${instdir
0e30: 7d 22 20 26 26 20 70 77 64 29 22 20 7c 7c 20 65  }" && pwd)" || e
0e40: 78 69 74 20 31 0a 0a 09 09 63 64 20 22 24 7b 77  xit 1....cd "${w
0e50: 6f 72 6b 64 69 72 7d 22 20 7c 7c 20 65 78 69 74  orkdir}" || exit
0e60: 20 31 0a 0a 09 09 2e 2f 63 6f 6e 66 69 67 75 72   1...../configur
0e70: 65 20 2d 2d 70 72 65 66 69 78 3d 27 27 20 22 24  e --prefix='' "$
0e80: 7b 63 6f 6e 66 69 67 75 72 65 5f 65 78 74 72 61  {configure_extra
0e90: 5b 40 5d 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a  [@]}" || exit 1.
0ea0: 0a 09 09 6d 61 6b 65 20 56 3d 31 20 7c 7c 20 65  ...make V=1 || e
0eb0: 78 69 74 20 31 0a 0a 09 09 6d 6b 64 69 72 20 22  xit 1....mkdir "
0ec0: 24 7b 69 6e 73 74 64 69 72 7d 2f 6c 69 62 22 0a  ${instdir}/lib".
0ed0: 09 09 63 70 20 73 72 63 2f 2e 6c 69 62 73 2f 6c  ..cp src/.libs/l
0ee0: 69 62 63 63 69 64 2e 61 20 22 24 7b 69 6e 73 74  ibccid.a "${inst
0ef0: 64 69 72 7d 2f 6c 69 62 22 0a 0a 09 09 6d 6b 64  dir}/lib"....mkd
0f00: 69 72 20 22 24 7b 69 6e 73 74 64 69 72 7d 2f 69  ir "${instdir}/i
0f10: 6e 63 6c 75 64 65 22 0a 09 09 2e 2f 73 72 63 2f  nclude"..../src/
0f20: 63 72 65 61 74 65 5f 49 6e 66 6f 5f 70 6c 69 73  create_Info_plis
0f30: 74 2e 70 6c 20 2e 2f 72 65 61 64 65 72 73 2f 73  t.pl ./readers/s
0f40: 75 70 70 6f 72 74 65 64 5f 72 65 61 64 65 72 73  upported_readers
0f50: 2e 74 78 74 20 73 72 63 2f 49 6e 66 6f 2e 70 6c  .txt src/Info.pl
0f60: 69 73 74 2e 73 72 63 20 2d 2d 74 61 72 67 65 74  ist.src --target
0f70: 3d 6c 69 62 63 63 69 64 2e 73 6f 20 2d 2d 76 65  =libccid.so --ve
0f80: 72 73 69 6f 6e 3d 31 2e 30 2e 30 20 7c 20 5c 0a  rsion=1.0.0 | \.
0f90: 09 09 09 73 65 64 20 27 2f 3c 6b 65 79 3e 69 66  ...sed '/<key>if
0fa0: 64 44 72 69 76 65 72 4f 70 74 69 6f 6e 73 2f 20  dDriverOptions/ 
0fb0: 7b 6e 3b 63 20 5c 27 24 27 5c 6e 27 27 3c 73 74  {n;c \'$'\n''<st
0fc0: 72 69 6e 67 3e 30 78 30 30 30 34 3c 2f 73 74 72  ring>0x0004</str
0fd0: 69 6e 67 3e 27 24 27 5c 6e 27 27 70 7d 27 20 7c  ing>'$'\n''p}' |
0fe0: 20 5c 0a 09 09 09 6f 64 20 2d 74 20 78 31 20 2d   \....od -t x1 -
0ff0: 76 20 7c 20 73 65 64 20 27 73 40 5e 5b 5e 20 5d  v | sed 's@^[^ ]
1000: 2a 20 40 40 3b 73 40 20 40 40 67 3b 73 40 2e 2e  * @@;s@ @@g;s@..
1010: 40 5c 5c 78 26 40 67 3b 24 20 64 3b 73 40 5e 40  @\\x&@g;$ d;s@^@
1020: 22 40 3b 73 40 24 40 22 40 27 20 3e 20 22 24 7b  "@;s@$@"@' > "${
1030: 69 6e 73 74 64 69 72 7d 2f 69 6e 63 6c 75 64 65  instdir}/include
1040: 2f 49 6e 66 6f 2e 70 6c 69 73 74 2e 68 22 0a 09  /Info.plist.h"..
1050: 29 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a 0a 09  ) || return 1...
1060: 72 6d 20 2d 72 66 20 22 24 7b 77 6f 72 6b 64 69  rm -rf "${workdi
1070: 72 7d 22 0a 0a 09 63 61 63 6b 65 79 43 68 72 6f  r}"...cackeyChro
1080: 6d 65 45 78 74 43 43 49 44 44 69 72 3d 22 24 28  meExtCCIDDir="$(
1090: 63 64 20 22 24 7b 69 6e 73 74 64 69 72 7d 22 20  cd "${instdir}" 
10a0: 26 26 20 70 77 64 29 22 20 7c 7c 20 72 65 74 75  && pwd)" || retu
10b0: 72 6e 20 31 0a 0a 09 72 65 74 75 72 6e 20 30 0a  rn 1...return 0.
10c0: 7d 0a 0a 66 75 6e 63 74 69 6f 6e 20 62 75 69 6c  }..function buil
10d0: 64 50 43 53 43 4c 69 74 65 28 29 20 7b 0a 09 6c  dPCSCLite() {..l
10e0: 6f 63 61 6c 20 76 65 72 73 69 6f 6e 20 75 72 6c  ocal version url
10f0: 20 70 6b 67 20 73 68 61 32 35 36 20 63 6f 6e 66   pkg sha256 conf
1100: 69 67 75 72 65 5f 65 78 74 72 61 0a 09 6c 6f 63  igure_extra..loc
1110: 61 6c 20 61 72 63 68 69 76 65 20 77 6f 72 6b 64  al archive workd
1120: 69 72 20 69 6e 73 74 64 69 72 0a 0a 09 62 75 69  ir instdir...bui
1130: 6c 64 4c 69 62 55 53 42 20 7c 7c 20 72 65 74 75  ldLibUSB || retu
1140: 72 6e 20 31 0a 0a 09 70 6b 67 3d 27 70 63 73 63  rn 1...pkg='pcsc
1150: 2d 6c 69 74 65 27 0a 09 76 65 72 73 69 6f 6e 3d  -lite'..version=
1160: 27 31 2e 38 2e 31 35 27 0a 09 75 72 6c 3d 22 68  '1.8.15'..url="h
1170: 74 74 70 73 3a 2f 2f 61 6c 69 6f 74 68 2e 64 65  ttps://alioth.de
1180: 62 69 61 6e 2e 6f 72 67 2f 66 72 73 2f 64 6f 77  bian.org/frs/dow
1190: 6e 6c 6f 61 64 2e 70 68 70 2f 66 69 6c 65 2f 34  nload.php/file/4
11a0: 31 35 37 2f 70 63 73 63 2d 6c 69 74 65 2d 24 7b  157/pcsc-lite-${
11b0: 76 65 72 73 69 6f 6e 7d 2e 74 61 72 2e 62 7a 32  version}.tar.bz2
11c0: 22 0a 09 73 68 61 32 35 36 3d 27 61 64 38 62 31  "..sha256='ad8b1
11d0: 66 33 64 32 63 35 39 64 33 61 39 36 36 63 62 32  f3d2c59d3a966cb2
11e0: 30 33 66 63 37 34 35 38 38 36 32 39 63 34 61 35  03fc74588629c4a5
11f0: 66 61 33 30 66 38 61 64 39 30 30 35 65 30 36 65  fa30f8ad9005e06e
1200: 66 37 61 61 34 34 35 64 33 34 31 27 0a 09 63 6f  f7aa445d341'..co
1210: 6e 66 69 67 75 72 65 5f 65 78 74 72 61 3d 28 0a  nfigure_extra=(.
1220: 09 09 2d 2d 64 69 73 61 62 6c 65 2d 73 68 61 72  ..--disable-shar
1230: 65 64 20 2d 2d 65 6e 61 62 6c 65 2d 73 74 61 74  ed --enable-stat
1240: 69 63 20 2d 2d 65 6e 61 62 6c 65 2d 75 73 62 20  ic --enable-usb 
1250: 2d 2d 64 69 73 61 62 6c 65 2d 6c 69 62 75 64 65  --disable-libude
1260: 76 20 2d 2d 64 69 73 61 62 6c 65 2d 70 6f 6c 6b  v --disable-polk
1270: 69 74 20 2d 2d 77 69 74 68 2d 70 69 63 0a 09 09  it --with-pic...
1280: 22 24 7b 67 6c 6f 62 61 6c 5f 63 6f 6e 66 69 67  "${global_config
1290: 75 72 65 5f 65 78 74 72 61 5b 40 5d 7d 22 0a 09  ure_extra[@]}"..
12a0: 29 0a 0a 09 61 72 63 68 69 76 65 3d 22 61 72 63  )...archive="arc
12b0: 68 69 76 65 2f 24 7b 70 6b 67 7d 2d 24 7b 76 65  hive/${pkg}-${ve
12c0: 72 73 69 6f 6e 7d 2e 74 61 72 2e 62 7a 32 22 0a  rsion}.tar.bz2".
12d0: 09 77 6f 72 6b 64 69 72 3d 22 77 6f 72 6b 64 69  .workdir="workdi
12e0: 72 2d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e  r-${RANDOM}${RAN
12f0: 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52  DOM}${RANDOM}${R
1300: 41 4e 44 4f 4d 7d 2e 62 75 69 6c 64 22 0a 09 69  ANDOM}.build"..i
1310: 6e 73 74 64 69 72 3d 22 77 6f 72 6b 64 69 72 2d  nstdir="workdir-
1320: 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f  ${RANDOM}${RANDO
1330: 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e  M}${RANDOM}${RAN
1340: 44 4f 4d 7d 2e 69 6e 73 74 22 0a 0a 09 64 6f 77  DOM}.inst"...dow
1350: 6e 6c 6f 61 64 20 22 24 7b 75 72 6c 7d 22 20 22  nload "${url}" "
1360: 24 7b 61 72 63 68 69 76 65 7d 22 20 22 24 7b 73  ${archive}" "${s
1370: 68 61 32 35 36 7d 22 20 7c 7c 20 72 65 74 75 72  ha256}" || retur
1380: 6e 20 31 0a 09 65 78 74 72 61 63 74 20 22 24 7b  n 1..extract "${
1390: 61 72 63 68 69 76 65 7d 22 20 22 24 7b 77 6f 72  archive}" "${wor
13a0: 6b 64 69 72 7d 22 20 7c 7c 20 72 65 74 75 72 6e  kdir}" || return
13b0: 20 31 0a 0a 09 28 0a 09 09 6d 6b 64 69 72 20 22   1...(...mkdir "
13c0: 24 7b 69 6e 73 74 64 69 72 7d 22 0a 0a 09 09 69  ${instdir}"....i
13d0: 6e 73 74 64 69 72 3d 22 24 28 63 64 20 22 24 7b  nstdir="$(cd "${
13e0: 69 6e 73 74 64 69 72 7d 22 20 26 26 20 70 77 64  instdir}" && pwd
13f0: 29 22 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09  )" || exit 1....
1400: 63 64 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20  cd "${workdir}" 
1410: 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09 2e 2f 63  || exit 1...../c
1420: 6f 6e 66 69 67 75 72 65 20 2d 2d 70 72 65 66 69  onfigure --prefi
1430: 78 3d 27 27 20 2d 2d 73 62 69 6e 64 69 72 3d 22  x='' --sbindir="
1440: 2f 62 69 6e 22 20 22 24 7b 63 6f 6e 66 69 67 75  /bin" "${configu
1450: 72 65 5f 65 78 74 72 61 5b 40 5d 7d 22 20 7c 7c  re_extra[@]}" ||
1460: 20 65 78 69 74 20 31 0a 09 09 6d 61 6b 65 20 56   exit 1...make V
1470: 3d 31 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 6d  =1 || exit 1...m
1480: 61 6b 65 20 56 3d 31 20 44 45 53 54 44 49 52 3d  ake V=1 DESTDIR=
1490: 22 24 7b 69 6e 73 74 64 69 72 7d 22 20 69 6e 73  "${instdir}" ins
14a0: 74 61 6c 6c 20 7c 7c 20 65 78 69 74 20 31 0a 09  tall || exit 1..
14b0: 29 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a 0a 09  ) || return 1...
14c0: 63 61 63 6b 65 79 43 68 72 6f 6d 65 45 78 74 50  cackeyChromeExtP
14d0: 43 53 43 4c 69 74 65 44 69 72 3d 22 24 28 63 64  CSCLiteDir="$(cd
14e0: 20 22 24 7b 69 6e 73 74 64 69 72 7d 22 20 26 26   "${instdir}" &&
14f0: 20 70 77 64 29 22 0a 09 65 78 70 6f 72 74 20 50   pwd)"..export P
1500: 43 53 43 5f 43 46 4c 41 47 53 3d 22 2d 49 24 7b  CSC_CFLAGS="-I${
1510: 63 61 63 6b 65 79 43 68 72 6f 6d 65 45 78 74 50  cackeyChromeExtP
1520: 43 53 43 4c 69 74 65 44 69 72 7d 2f 69 6e 63 6c  CSCLiteDir}/incl
1530: 75 64 65 2f 50 43 53 43 22 0a 09 65 78 70 6f 72  ude/PCSC"..expor
1540: 74 20 50 43 53 43 5f 4c 49 42 53 3d 22 2d 4c 24  t PCSC_LIBS="-L$
1550: 7b 63 61 63 6b 65 79 43 68 72 6f 6d 65 45 78 74  {cackeyChromeExt
1560: 50 43 53 43 4c 69 74 65 44 69 72 7d 2f 6c 69 62  PCSCLiteDir}/lib
1570: 20 2d 6c 70 63 73 63 6c 69 74 65 20 2d 70 74 68   -lpcsclite -pth
1580: 72 65 61 64 22 0a 0a 09 62 75 69 6c 64 43 43 49  read"...buildCCI
1590: 44 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a 0a 09  D || return 1...
15a0: 72 6d 20 2d 72 66 20 22 24 7b 69 6e 73 74 64 69  rm -rf "${instdi
15b0: 72 7d 22 0a 09 75 6e 73 65 74 20 50 43 53 43 5f  r}"..unset PCSC_
15c0: 43 46 4c 41 47 53 20 50 43 53 43 5f 4c 49 42 53  CFLAGS PCSC_LIBS
15d0: 20 63 61 63 6b 65 79 43 68 72 6f 6d 65 45 78 74   cackeyChromeExt
15e0: 50 43 53 43 4c 69 74 65 44 69 72 0a 0a 09 72 6d  PCSCLiteDir...rm
15f0: 20 2d 72 66 20 22 24 7b 77 6f 72 6b 64 69 72 7d   -rf "${workdir}
1600: 22 0a 09 65 78 74 72 61 63 74 20 22 24 7b 61 72  "..extract "${ar
1610: 63 68 69 76 65 7d 22 20 22 24 7b 77 6f 72 6b 64  chive}" "${workd
1620: 69 72 7d 22 20 7c 7c 20 72 65 74 75 72 6e 20 31  ir}" || return 1
1630: 0a 0a 09 28 0a 09 09 6d 6b 64 69 72 20 22 24 7b  ...(...mkdir "${
1640: 69 6e 73 74 64 69 72 7d 22 0a 0a 09 09 69 6e 73  instdir}"....ins
1650: 74 64 69 72 3d 22 24 28 63 64 20 22 24 7b 69 6e  tdir="$(cd "${in
1660: 73 74 64 69 72 7d 22 20 26 26 20 70 77 64 29 22  stdir}" && pwd)"
1670: 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09 63 64   || exit 1....cd
1680: 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22 20 7c 7c   "${workdir}" ||
1690: 20 65 78 69 74 20 31 0a 0a 09 09 73 65 64 20 2d   exit 1....sed -
16a0: 69 20 27 73 40 5e 70 63 73 63 64 5f 4c 44 46 4c  i 's@^pcscd_LDFL
16b0: 41 47 53 5b 5b 3a 73 70 61 63 65 3a 5d 5d 2a 3d  AGS[[:space:]]*=
16c0: 40 26 20 2d 61 6c 6c 2d 73 74 61 74 69 63 20 40  @& -all-static @
16d0: 27 20 73 72 63 2f 4d 61 6b 65 66 69 6c 65 2e 69  ' src/Makefile.i
16e0: 6e 0a 0a 09 09 66 6f 72 20 70 61 74 63 68 46 69  n....for patchFi
16f0: 6c 65 20 69 6e 20 22 24 7b 70 61 74 63 68 44 69  le in "${patchDi
1700: 72 7d 22 2f 70 63 73 63 2d 6c 69 74 65 2d 2a 2e  r}"/pcsc-lite-*.
1710: 64 69 66 66 3b 20 64 6f 0a 09 09 09 69 66 20 5b  diff; do....if [
1720: 20 21 20 2d 66 20 22 24 7b 70 61 74 63 68 46 69   ! -f "${patchFi
1730: 6c 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09  le}" ]; then....
1740: 09 63 6f 6e 74 69 6e 75 65 0a 09 09 09 66 69 0a  .continue....fi.
1750: 0a 09 09 09 70 61 74 63 68 20 2d 70 31 20 3c 20  ....patch -p1 < 
1760: 22 24 7b 70 61 74 63 68 46 69 6c 65 7d 22 20 7c  "${patchFile}" |
1770: 7c 20 65 78 69 74 20 31 0a 09 09 64 6f 6e 65 0a  | exit 1...done.
1780: 0a 09 09 63 70 20 22 24 7b 63 61 63 6b 65 79 43  ...cp "${cackeyC
1790: 68 72 6f 6d 65 45 78 74 43 43 49 44 44 69 72 7d  hromeExtCCIDDir}
17a0: 2f 69 6e 63 6c 75 64 65 2f 49 6e 66 6f 2e 70 6c  /include/Info.pl
17b0: 69 73 74 2e 68 22 20 73 72 63 2f 20 7c 7c 20 65  ist.h" src/ || e
17c0: 78 69 74 20 31 0a 0a 09 09 65 78 74 72 61 44 65  xit 1....extraDe
17d0: 66 69 6e 65 73 3d 27 2d 44 50 43 53 43 4c 49 54  fines='-DPCSCLIT
17e0: 45 5f 53 54 41 54 49 43 5f 44 52 49 56 45 52 20  E_STATIC_DRIVER 
17f0: 2d 44 49 46 44 48 41 4e 44 4c 45 52 76 33 27 0a  -DIFDHANDLERv3'.
1800: 0a 09 09 2e 2f 63 6f 6e 66 69 67 75 72 65 20 2d  ..../configure -
1810: 2d 70 72 65 66 69 78 3d 27 27 20 2d 2d 73 62 69  -prefix='' --sbi
1820: 6e 64 69 72 3d 22 2f 62 69 6e 22 20 22 24 7b 63  ndir="/bin" "${c
1830: 6f 6e 66 69 67 75 72 65 5f 65 78 74 72 61 5b 40  onfigure_extra[@
1840: 5d 7d 22 20 43 46 4c 41 47 53 3d 22 2d 67 33 20  ]}" CFLAGS="-g3 
1850: 2d 67 67 64 62 33 20 24 7b 43 46 4c 41 47 53 7d  -ggdb3 ${CFLAGS}
1860: 20 24 7b 65 78 74 72 61 44 65 66 69 6e 65 73 7d   ${extraDefines}
1870: 22 20 43 50 50 46 4c 41 47 53 3d 22 24 7b 43 50  " CPPFLAGS="${CP
1880: 50 46 4c 41 47 53 7d 20 24 7b 65 78 74 72 61 44  PFLAGS} ${extraD
1890: 65 66 69 6e 65 73 7d 22 20 4c 49 42 53 3d 22 24  efines}" LIBS="$
18a0: 7b 4c 49 42 53 7d 20 2d 4c 24 7b 63 61 63 6b 65  {LIBS} -L${cacke
18b0: 79 43 68 72 6f 6d 65 45 78 74 43 43 49 44 44 69  yChromeExtCCIDDi
18c0: 72 7d 2f 6c 69 62 20 2d 6c 63 63 69 64 22 20 7c  r}/lib -lccid" |
18d0: 7c 20 65 78 69 74 20 31 0a 09 09 6d 61 6b 65 20  | exit 1...make 
18e0: 56 3d 31 20 7c 7c 20 65 78 69 74 20 31 0a 09 09  V=1 || exit 1...
18f0: 6d 61 6b 65 20 56 3d 31 20 44 45 53 54 44 49 52  make V=1 DESTDIR
1900: 3d 22 24 7b 69 6e 73 74 64 69 72 7d 22 20 69 6e  ="${instdir}" in
1910: 73 74 61 6c 6c 20 7c 7c 20 65 78 69 74 20 31 0a  stall || exit 1.
1920: 09 29 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a 0a  .) || return 1..
1930: 09 72 6d 20 2d 72 66 20 22 24 7b 63 61 63 6b 65  .rm -rf "${cacke
1940: 79 43 68 72 6f 6d 65 45 78 74 4c 69 62 55 53 42  yChromeExtLibUSB
1950: 44 69 72 7d 22 0a 09 75 6e 73 65 74 20 4c 49 42  Dir}"..unset LIB
1960: 55 53 42 5f 4c 49 42 53 20 4c 49 42 55 53 42 5f  USB_LIBS LIBUSB_
1970: 43 46 4c 41 47 53 0a 0a 09 72 6d 20 2d 72 66 20  CFLAGS...rm -rf 
1980: 22 24 7b 63 61 63 6b 65 79 43 68 72 6f 6d 65 45  "${cackeyChromeE
1990: 78 74 43 43 49 44 44 69 72 7d 22 0a 09 72 6d 20  xtCCIDDir}"..rm 
19a0: 2d 72 66 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22  -rf "${workdir}"
19b0: 0a 0a 09 63 61 63 6b 65 79 43 68 72 6f 6d 65 45  ...cackeyChromeE
19c0: 78 74 50 43 53 43 4c 69 74 65 44 69 72 3d 22 24  xtPCSCLiteDir="$
19d0: 28 63 64 20 22 24 7b 69 6e 73 74 64 69 72 7d 22  (cd "${instdir}"
19e0: 20 26 26 20 70 77 64 29 22 0a 09 65 78 70 6f 72   && pwd)"..expor
19f0: 74 20 50 43 53 43 5f 43 46 4c 41 47 53 3d 22 2d  t PCSC_CFLAGS="-
1a00: 49 24 7b 63 61 63 6b 65 79 43 68 72 6f 6d 65 45  I${cackeyChromeE
1a10: 78 74 50 43 53 43 4c 69 74 65 44 69 72 7d 2f 69  xtPCSCLiteDir}/i
1a20: 6e 63 6c 75 64 65 2f 50 43 53 43 22 0a 09 65 78  nclude/PCSC"..ex
1a30: 70 6f 72 74 20 50 43 53 43 5f 4c 49 42 53 3d 22  port PCSC_LIBS="
1a40: 2d 4c 24 7b 63 61 63 6b 65 79 43 68 72 6f 6d 65  -L${cackeyChrome
1a50: 45 78 74 50 43 53 43 4c 69 74 65 44 69 72 7d 2f  ExtPCSCLiteDir}/
1a60: 6c 69 62 20 2d 6c 70 63 73 63 6c 69 74 65 20 2d  lib -lpcsclite -
1a70: 70 74 68 72 65 61 64 22 0a 0a 09 63 70 20 22 24  pthread"...cp "$
1a80: 7b 63 61 63 6b 65 79 43 68 72 6f 6d 65 45 78 74  {cackeyChromeExt
1a90: 50 43 53 43 4c 69 74 65 44 69 72 7d 2f 62 69 6e  PCSCLiteDir}/bin
1aa0: 2f 70 63 73 63 64 22 20 22 24 7b 6f 75 74 64 69  /pcscd" "${outdi
1ab0: 72 7d 22 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a  r}" || return 1.
1ac0: 0a 09 72 65 74 75 72 6e 20 30 0a 7d 0a 0a 66 75  ..return 0.}..fu
1ad0: 6e 63 74 69 6f 6e 20 62 75 69 6c 64 43 41 43 4b  nction buildCACK
1ae0: 65 79 28 29 20 7b 0a 09 6c 6f 63 61 6c 20 66 69  ey() {..local fi
1af0: 6c 65 20 63 6f 70 69 65 64 0a 0a 09 28 0a 09 09  le copied...(...
1b00: 63 64 20 2e 2e 2f 2e 2e 20 7c 7c 20 65 78 69 74  cd ../.. || exit
1b10: 20 31 0a 0a 09 09 6d 61 6b 65 20 64 69 73 74 63   1....make distc
1b20: 6c 65 61 6e 0a 0a 09 09 2e 2f 63 6f 6e 66 69 67  lean...../config
1b30: 75 72 65 20 2d 2d 77 69 74 68 2d 70 63 73 63 2d  ure --with-pcsc-
1b40: 68 65 61 64 65 72 73 3d 22 24 7b 63 61 63 6b 65  headers="${cacke
1b50: 79 43 68 72 6f 6d 65 45 78 74 50 43 53 43 4c 69  yChromeExtPCSCLi
1b60: 74 65 44 69 72 7d 2f 69 6e 63 6c 75 64 65 2f 50  teDir}/include/P
1b70: 43 53 43 22 20 2d 2d 77 69 74 68 2d 70 63 73 63  CSC" --with-pcsc
1b80: 2d 6c 69 62 73 3d 22 24 7b 50 43 53 43 5f 4c 49  -libs="${PCSC_LI
1b90: 42 53 7d 22 20 7c 7c 20 65 78 69 74 20 31 0a 09  BS}" || exit 1..
1ba0: 09 6d 61 6b 65 20 7c 7c 20 65 78 69 74 20 31 0a  .make || exit 1.
1bb0: 09 29 20 7c 7c 20 72 65 74 75 72 6e 20 31 0a 0a  .) || return 1..
1bc0: 09 63 6f 70 69 65 64 3d 27 30 27 0a 09 66 6f 72  .copied='0'..for
1bd0: 20 66 69 6c 65 20 69 6e 20 2e 2e 2f 2e 2e 2f 6c   file in ../../l
1be0: 69 62 63 61 63 6b 65 79 7b 2c 5f 67 7d 2e 7b 73  ibcackey{,_g}.{s
1bf0: 6f 2c 64 6c 6c 2c 64 79 6c 69 62 7d 3b 20 64 6f  o,dll,dylib}; do
1c00: 0a 09 09 69 66 20 5b 20 2d 66 20 22 24 7b 66 69  ...if [ -f "${fi
1c10: 6c 65 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09 09  le}" ]; then....
1c20: 63 70 20 22 24 7b 66 69 6c 65 7d 22 20 22 24 7b  cp "${file}" "${
1c30: 6f 75 74 64 69 72 7d 22 0a 09 09 09 63 6f 70 69  outdir}"....copi
1c40: 65 64 3d 27 31 27 0a 09 09 66 69 0a 09 64 6f 6e  ed='1'...fi..don
1c50: 65 0a 0a 09 69 66 20 5b 20 22 24 7b 63 6f 70 69  e...if [ "${copi
1c60: 65 64 7d 22 20 3d 20 27 30 27 20 5d 3b 20 74 68  ed}" = '0' ]; th
1c70: 65 6e 0a 09 09 65 63 68 6f 20 22 65 72 72 6f 72  en...echo "error
1c80: 3a 20 55 6e 61 62 6c 65 20 74 6f 20 63 6f 70 79  : Unable to copy
1c90: 20 62 75 69 6c 74 20 6c 69 62 63 61 63 6b 65 79   built libcackey
1ca0: 20 74 6f 20 6c 6f 63 61 6c 20 64 69 72 65 63 74   to local direct
1cb0: 6f 72 79 22 20 3e 26 32 0a 0a 09 09 72 65 74 75  ory" >&2....retu
1cc0: 72 6e 20 31 0a 09 66 69 0a 0a 09 72 6d 20 2d 72  rn 1..fi...rm -r
1cd0: 66 20 22 24 7b 63 61 63 6b 65 79 43 68 72 6f 6d  f "${cackeyChrom
1ce0: 65 45 78 74 50 43 53 43 4c 69 74 65 44 69 72 7d  eExtPCSCLiteDir}
1cf0: 22 0a 09 75 6e 73 65 74 20 50 43 53 43 5f 43 46  "..unset PCSC_CF
1d00: 4c 41 47 53 20 50 43 53 43 5f 4c 49 42 53 0a 0a  LAGS PCSC_LIBS..
1d10: 09 72 65 74 75 72 6e 20 30 0a 7d 0a 0a 6f 75 74  .return 0.}..out
1d20: 64 69 72 3d 22 77 6f 72 6b 64 69 72 2d 24 7b 52  dir="workdir-${R
1d30: 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d 7d 24  ANDOM}${RANDOM}$
1d40: 7b 52 41 4e 44 4f 4d 7d 24 7b 52 41 4e 44 4f 4d  {RANDOM}${RANDOM
1d50: 7d 2e 6f 75 74 22 0a 72 6d 20 2d 72 66 20 22 24  }.out".rm -rf "$
1d60: 7b 6f 75 74 64 69 72 7d 22 0a 6d 6b 64 69 72 20  {outdir}".mkdir 
1d70: 22 24 7b 6f 75 74 64 69 72 7d 22 20 7c 7c 20 65  "${outdir}" || e
1d80: 78 69 74 20 31 0a 0a 62 75 69 6c 64 50 43 53 43  xit 1..buildPCSC
1d90: 4c 69 74 65 20 7c 7c 20 65 78 69 74 20 31 0a 0a  Lite || exit 1..
1da0: 62 75 69 6c 64 43 41 43 4b 65 79 20 7c 7c 20 65  buildCACKey || e
1db0: 78 69 74 20 31 0a 0a 65 78 69 74 20 30 0a        xit 1..exit 0.